<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { computed, ref } from 'vue'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { useRoute, useRouter } from 'vue-router'
    import { UserApi } from '@/api/user/UserApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { CreateUserDto } from '@/api/user/CreateUserDto'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferInjectionKey,
    } from '@/shared/constants'
    import { useUserValidation } from '@/shared/administration/composables/users/useUserValidation'
    import { requiredInject } from '@/shared/helpers/types'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'
    import SRoleList from '@/serviceOffer/components/administration/SRoleList.vue'

    // variables d'état
    const formFieldsAreValid = ref<boolean>(false)

    const { rules } = useUserValidation()

    const userDto = ref<CreateUserDto>({
        email: '',
        roles: [],
    })

    const { getSiblingRoute } = useBreadcrumb()
    const isProcessing = ref<boolean>(false)

    const router = useRouter()
    const route = useRoute()

    const msal = useMsal()

    const userApi = new UserApi(msal)

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)

    const serviceOffer = requiredInject(serviceOfferInjectionKey)

    async function createUser() {
        try {
            // affichage du loader
            isProcessing.value = true

            const createdUser = await userApi.createUserByServiceOffer(
                serviceOfferId.value,
                userDto.value
            )

            emitSnackBar(`Utilisateur "${createdUser.email}" créé`, 'primary')
            router.push(getSiblingRoute(route, ''))
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
            router.push(getSiblingRoute(route, ''))
        } finally {
            // masquage du loader
            isProcessing.value = false
        }
    }

    const addOrRemoveRoleFromList = (role: string) => {
        const index = userDto.value.roles.indexOf(role)
        if (index !== undefined && index !== -1) {
            userDto.value.roles.splice(index, 1)
        } else {
            userDto.value.roles.push(role)
        }
    }

    const rolesAreValid = computed(() => userDto.value.roles.length > 0)
</script>

<template>
    <s-contextual-navbar
        page-title="Ajouter un utilisateur"
    ></s-contextual-navbar>
    <v-main>
        <s-content-container>
            <v-form
                v-if="serviceOffer"
                ref="form"
                v-model="formFieldsAreValid"
                class="mx-auto"
                @submit.prevent="createUser()"
            >
                <v-text-field
                    v-model="userDto.email"
                    label="Email"
                    class="mb-3"
                    :rules="[rules.hasEmail, rules.hasValidEmail]"
                    data-cy="email"
                ></v-text-field>
                <h3>Rôles de l'offre de service {{ serviceOffer.title }}</h3>
                <s-role-list
                    v-for="serviceOfferRole in serviceOffer.availableRoles"
                    :key="serviceOfferRole.value"
                    :role="serviceOfferRole"
                    :selected-roles="userDto.roles"
                    @toggle-role="
                        addOrRemoveRoleFromList(serviceOfferRole.value)
                    "
                />
                <s-action-button
                    icon="mdi-check"
                    label="Enregistrer"
                    data-cy="register-user-button"
                    :disabled="!formFieldsAreValid || !rolesAreValid"
                    :loading="isProcessing"
                    display="floating-fixed"
                    position="right"
                    type="submit"
                >
                </s-action-button>
            </v-form>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
